<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_OrderedPrice ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_OrderedPrice extends AbstractStructArrayBase
{
    /**
     * The AdultAdditional
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_OrderedPrice[]
     */
    public $AdultAdditional;
    /**
     * Constructor method for ArrayOfJPSOAP_OrderedPrice
     * @uses ArrayOfJPSOAP_OrderedPrice::setAdultAdditional()
     * @param \StructType\JPSOAP_OrderedPrice[] $adultAdditional
     */
    public function __construct(array $adultAdditional = array())
    {
        $this
            ->setAdultAdditional($adultAdditional);
    }
    /**
     * Get AdultAdditional value
     * @return \StructType\JPSOAP_OrderedPrice[]|null
     */
    public function getAdultAdditional()
    {
        return $this->AdultAdditional;
    }
    /**
     * Set AdultAdditional value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedPrice[] $adultAdditional
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice
     */
    public function setAdultAdditional(array $adultAdditional = array())
    {
        foreach ($adultAdditional as $arrayOfJPSOAP_OrderedPriceAdultAdditionalItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_OrderedPriceAdultAdditionalItem instanceof \StructType\JPSOAP_OrderedPrice) {
                throw new \InvalidArgumentException(sprintf('The AdultAdditional property can only contain items of \StructType\JPSOAP_OrderedPrice, "%s" given', is_object($arrayOfJPSOAP_OrderedPriceAdultAdditionalItem) ? get_class($arrayOfJPSOAP_OrderedPriceAdultAdditionalItem) : gettype($arrayOfJPSOAP_OrderedPriceAdultAdditionalItem)), __LINE__);
            }
        }
        $this->AdultAdditional = $adultAdditional;
        return $this;
    }
    /**
     * Add item to AdultAdditional value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedPrice $item
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice
     */
    public function addToAdultAdditional(\StructType\JPSOAP_OrderedPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_OrderedPrice) {
            throw new \InvalidArgumentException(sprintf('The AdultAdditional property can only contain items of \StructType\JPSOAP_OrderedPrice, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AdultAdditional[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdultAdditional
     */
    public function getAttributeName()
    {
        return 'AdultAdditional';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
